class eda():
	def print_null_cntNpct(data_list):         # function to count null values
		#print_null_cntNpct([train])
		#Make sure name is assigned to the given list as train.name = 'Training Set'
		
		for data in data_list:
			import pandas as pd
			#get missing columns name
			mask = data.isnull().sum().sort_values(ascending=False)
			mask = mask[mask>0].index
			
			#print missing features in the set
			print('\033[1m' + "Total Missing Features : {}.".format(len(mask))+'\033[0m')
			print("")
			
			tmp = pd.DataFrame()
			tmp["Missing_Count"] = data[mask].isnull().sum()
			tmp["Missing_Percentage"] = data[mask].isnull().sum()/len(data)
			#print(i.name)
			print(tmp.sort_values(ascending=False,by=['Missing_Percentage']))
			print('='*44)
			
		if(len(data_list)>1):
			print('\033[1m' + "All Missing Column  in the data frames : "+ '\033[0m')
			print("")
			print(set(data_list[0].isnull().sum()[data_list[0].isnull().sum()>0].index) | set(data_list[1].isnull().sum()[data_list[1].isnull().sum()>0].index))
    
#=================================================================================================================
	# function to get te cardinality
	def print_cardinalityNdifference(train,test,feature_list):
		
		import pandas as pd
		for col in feature_list:
			print('\033[1m' + "->Cardinality of",col+":",train[col].nunique(),'\033[0m')
			
			left = pd.DataFrame([train[col].value_counts(),train[col].value_counts(normalize=True)],index=['Left_Count','Left_%']).T
			right = pd.DataFrame([test[col].value_counts(),test[col].value_counts(normalize=True)],index=['Right_Count','Right_%']).T
			tmp = pd.concat([left,right],axis=1,join='outer',sort=True)
			
			print(tmp)
			print(" ")
			print('\033[1m'+"Difference :"+'\033[0m',set(train[col]) ^ set(test[col]))
			print("-"*55)
#=================================================================================================================
	def print_num_eda(train,target):
		import pandas as pd
		import partner as pal
		df = pd.DataFrame()
		df['skew'] = train.skew().sort_index()
		df['correlation'] = train.corr()[target].sort_index()
		df = df.sort_values('correlation',ascending=False).reset_index()
		df = df.rename(columns = {'index':'Feature'})
		
		#extracting feature details
		col = train.select_dtypes(exclude='object').columns
		tmp = pal.eda.print_cat_eda(train[col])
		
		tmp = pd.merge(left=df,right=tmp,how='inner',on='Feature')
		return tmp
#=================================================================================================================
	def print_cat_eda(train):
		import pandas as pd
		eda = pd.DataFrame()
		for col in train.columns:
			tmp = pd.DataFrame()
			tmp['Feature'] = [col]
			tmp['values'] = [train[col].unique()]
			tmp['values_count_incNA'] = len(list(train[col].unique()))
			tmp['values_count_noNA'] = int(train[col].nunique())
			tmp['num_miss'] = train[col].isnull().sum()
			tmp['pct_miss'] = (train[col].isnull().sum()/ len(train)).round(3)*100
			eda = eda.append(tmp)
		eda = eda.reset_index()
		del eda['index']
		return eda.sort_values(by='values_count_incNA',ascending=False)
#=================================================================================================================
	def summarize(train,test,target):
		import pandas as pd
		import partner as pal
		from IPython.display import display
		pd.set_option('display.max_columns', 500)
		pd.set_option('display.max_rows', 500)
		import warnings
		warnings.filterwarnings("ignore") 

		cat_col = train.select_dtypes(include='object').columns
		num_col = train.select_dtypes(exclude='object').columns
		feature = test.columns

		#Print shape
		print('1. Shapes of the data set is - ')
		print(" "*3,"Train",train.shape)
		print(" "*3,"Test",test.shape)

		#Print head(5)
		print('=='*60)
		print('2. Sample of the train data set is - ')
		display(train.head())

		#Print Statistical Summary
		print('=='*60)
		print('3. Statistical Summary of train data set is - ')    
		display(train.describe())

		#Print Numerical EDA
		print('=='*60)
		print('4. Numerical EDA of train data set is - ')    
		display(pal.eda.print_num_eda(train,target))

		#Print Categorical EDA
		print('=='*60)
		print('5. Categorical EDA of train data set is - ')    
		try:
			display(pal.eda.print_cat_eda(train[cat_col]))
		except:
			print('No Categorical feature present')
			pass

		#Print Numerical Plot
		print('=='*60)
		print('6. Numerical Plot of train data set is - ')   
		pal.display.NumericalDistribution(train,num_col,target)

		#Print Categorical Plot
		print('=='*60)
		print('7. Categorical Plot of train data set is - ')
		try:
			pal.display.CategoricalDistribution(train,cat_col,target)
		except:
			print('No Categorical feature present')
			pass

		#Print Categorical Cardinality Check
		print('=='*60)
		print('8. Categorical features Cardinalities and Difference of train & test data set is - ')
		try:
			pal.eda.print_cardinalityNdifference(train,test,cat_col)
		except:
			print('No Categorical feature present')
			pass

		#Print Numerical Distribution Check
		num_feat = num_col.tolist()
		if target in num_feat:
			num_feat.remove(target)

		print('=='*60)
		print('9. Numerical distribution of train & test data set is - ')      
		pal.eda.print_cardinalityNdifference(train,test,num_feat)

		#Print Data type check
		print('=='*60)
		print('10. Data Type difference between train & test data set is - ')  
		pal.eda.print_dtypeDiff(train,test)

		#Print Null Counts and Percentages
		print('=='*60)
		print('11. Null counts and Percentages for train & test data set is - ')
		pal.eda.print_null_cntNpct([train,test])
	
#=================================================================================================================
	def print_dtypeDiff(train,test):
		columns = test.columns
		count = 1
		for i in range(test.shape[1]):
			if train[columns[i]].dtype != test[columns[i]].dtype:
				print("{}.{}".format(count,columns[i]))
				count=count+1
#=================================================================================================================
	def change_dtypeDiff(train,test):
		columns = test.columns
		for i in range(test.shape[1]):
			if (train[columns[i]].dtype == test[columns[i]].dtype) == False:
				train[columns[i]] = train[columns[i]].astype(test[columns[i]].dtype)
				print('Data type changed:',i)
#=================================================================================================================
	def print_VariableTransformation(train,target,feature_list):
		#print_VariableTransformation(train,'SalePrice',cont)
		import pandas as pd
		import numpy as np
		import scipy.stats as stats
		from IPython.display import display

		feature_list = [i for i in feature_list if i != target]
		transfomer_list = ['Original','Log','Log1p','Reciprocal','SquareRoot','Exponential','BoxCox','YeoJohnson']
		results = pd.DataFrame(index=transfomer_list,columns=feature_list)

		for feature in feature_list:
			results.loc['Original',feature] = pd.concat([train[feature].to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]
			results.loc['Log',feature] = pd.concat([np.log(train[feature]).to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]
			results.loc['Log1p',feature] = pd.concat([np.log1p(train[feature]).to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]
			results.loc['Reciprocal',feature] = pd.concat([(1/train[feature]).to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]
			results.loc['SquareRoot',feature] = pd.concat([(train[feature]**(1/2)).to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]
			results.loc['Exponential',feature] = pd.concat([(train[feature]**(1/1.5)).to_frame(),train[target].to_frame()],axis=1).corr().loc[feature,target]

			#Box Cox
			try:
				tmp, param = stats.boxcox(train[feature])
				tmp = pd.DataFrame(tmp, columns=[feature])
				results.loc['BoxCox',feature] = pd.concat([tmp,train[target].to_frame()],axis=1).corr().loc[feature,target]
			except:
				pass

			# Yeo Johnson
			try:
				tmp, param = stats.yeojohnson(train[feature].astype('float64'))
				tmp = pd.DataFrame(tmp, columns=[feature])
				results.loc['YeoJohnson',feature] = pd.concat([tmp,train[target].to_frame()],axis=1).corr().loc[feature,target]
			except:
				pass

			results.loc['AbsMax',feature] = results[feature].fillna(0).abs().idxmax()

			final = results.T.sort_values('AbsMax')

		display(final)
		display(final.groupby('AbsMax').groups)
#=================================================================================================================
	def find_normal_boundaries(df, variable, distance):
		upper_boundary = df[variable].mean() + distance * df[variable].std()
		lower_boundary = df[variable].mean() - distance * df[variable].std()
		return upper_boundary, lower_boundary

	def find_skewed_boundaries(df, variable, distance):
		IQR = df[variable].quantile(0.75) - df[variable].quantile(0.25)
		lower_boundary = df[variable].quantile(0.25) - (IQR * distance)
		upper_boundary = df[variable].quantile(0.75) + (IQR * distance)
		return upper_boundary, lower_boundary

#=================================================================================================================
	def analyseWithPCA(data,feature_list,kernal = False):
		from sklearn.preprocessing import StandardScaler
		from sklearn.decomposition import PCA,KernelPCA
		
		explained_variance=[]
		
		#apply Scaling
		ss = StandardScaler()
		x_train = ss.fit_transform(data[feature_list])

		# apply PCA
		if kernal == True:
			pca = KernelPCA(n_components=2, kernel='rbf')
		else:
			pca = PCA(n_components= None)
			x_train = pca.fit_transform(x_train)
			explained_variance = pca.explained_variance_ratio_    # percentage variance explained

		return explained_variance
#=================================================================================================================
	def print_corr(df,feature_list,threshold):
		import pandas as pd

		pd.set_option('display.max_rows',500)
		pd.set_option('display.max_colwidth',500)

		df_cor = df[feature_list].corr()
		result = pd.DataFrame(columns=['Feature_1','Feature_2','corr'])

		for i in range(len(df_cor.columns)):
			feat2 = ''
			cor = ''
			for j in range(len(df_cor.index)):
				if (abs(df_cor.iloc[i,j]) > threshold) & (df_cor.columns[i]!=df_cor.index[j]):
					feat2 = feat2+',"'+df_cor.index[j]+'"'
					cor = round(df_cor.iloc[i,j],2).astype('str')+','+cor
			result = result.append({'Feature_1':df_cor.columns[i],'Feature_2':feat2,'corr':cor},ignore_index=True)

		mask = [True]*len(result)
		for i in range(0,len(result)):
			if len(result.Feature_2[i])==0:
				mask[i] = False

		result = result[mask].sort_values(['Feature_1','corr'],ascending=False).reset_index()
		del result['index']
		return result
#=================================================================================================================

#################################################################################################################################
class ml():
	def apply_classifier(trainData,x_list,y_list,n_splits):
		
		#Common Model Algorithms
		import pandas as pd
		import warnings
		warnings.filterwarnings('ignore')
		from sklearn import svm, tree, linear_model, neighbors, naive_bayes, ensemble, discriminant_analysis, gaussian_process
		from xgboost import XGBClassifier
		from sklearn.model_selection import ShuffleSplit,cross_validate

		#Machine Learning Algorithm (MLA) Selection and Initialization
		MLA = [
			#Ensemble Methods
			ensemble.AdaBoostClassifier(),
			ensemble.BaggingClassifier(),
			ensemble.ExtraTreesClassifier(),
			ensemble.GradientBoostingClassifier(),
			ensemble.RandomForestClassifier(),

			#Gaussian Processes
			gaussian_process.GaussianProcessClassifier(),

			#GLM
			linear_model.LogisticRegressionCV(),
			linear_model.PassiveAggressiveClassifier(),
			linear_model.RidgeClassifierCV(),
			linear_model.SGDClassifier(),
			linear_model.Perceptron(),

			#Navies Bayes
			naive_bayes.BernoulliNB(),
			naive_bayes.GaussianNB(),

			#Nearest Neighbor
			neighbors.KNeighborsClassifier(),

			#SVM
			svm.SVC(probability=True),
			svm.NuSVC(probability=True),
			svm.LinearSVC(),

			#Trees    
			tree.DecisionTreeClassifier(),
			tree.ExtraTreeClassifier(),

			#Discriminant Analysis
			discriminant_analysis.LinearDiscriminantAnalysis(),
			discriminant_analysis.QuadraticDiscriminantAnalysis(),


			#xgboost: http://xgboost.readthedocs.io/en/latest/model.html
			XGBClassifier()    
			]



		#split dataset in cross-validation with this splitter class: http://scikit-learn.org/stable/modules/generated/sklearn.model_selection.ShuffleSplit.html#sklearn.model_selection.ShuffleSplit
		#note: this is an alternative to train_test_split
		cv_split = ShuffleSplit(n_splits = n_splits, test_size = .3, train_size = .6, random_state = 0 ) # run model 10x with 60/30 split intentionally leaving out 10%

		#create table to compare MLA metrics
		MLA_columns = ['MLA Name', 'MLA Parameters','MLA Train Accuracy Mean', 'MLA Test Accuracy Mean', 'MLA Test Accuracy 3*STD' ,'MLA Time']
		MLA_compare = pd.DataFrame(columns = MLA_columns)

		#create table to compare MLA predictions
		MLA_predict = trainData[y_list]

		#index through MLA and save performance to table
		row_index = 0
		for alg in MLA:

			#set name and parameters
			MLA_name = alg.__class__.__name__
			MLA_compare.loc[row_index, 'MLA Name'] = MLA_name
			MLA_compare.loc[row_index, 'MLA Parameters'] = str(alg.get_params())

			#score model with cross validation: http://scikit-learn.org/stable/modules/generated/sklearn.model_selection.cross_validate.html#sklearn.model_selection.cross_validate
			cv_results = cross_validate(alg, trainData[x_list], trainData[y_list], cv  = cv_split,return_train_score=True)

			MLA_compare.loc[row_index, 'MLA Time'] = cv_results['fit_time'].mean()
			MLA_compare.loc[row_index, 'MLA Test Accuracy Mean'] = cv_results['test_score'].mean()   
			MLA_compare.loc[row_index, 'MLA Train Accuracy Mean'] = cv_results['train_score'].mean()
			#if this is a non-bias random sample, then +/-3 standard deviations (std) from the mean, should statistically capture 99.7% of the subsets
			MLA_compare.loc[row_index, 'MLA Test Accuracy 3*STD'] = cv_results['test_score'].std()*3   #let's know the worst that can happen!


			#save MLA predictions - see section 6 for usage
			alg.fit(trainData[x_list], trainData[y_list])
			MLA_predict[MLA_name] = alg.predict(trainData[x_list])

			row_index+=1


		#print and sort table: https://pandas.pydata.org/pandas-docs/stable/generated/pandas.DataFrame.sort_values.html
		MLA_compare.sort_values(by = ['MLA Test Accuracy Mean'], ascending = False, inplace = True)
		return MLA_compare
		#MLA_predict
#=================================================================================================================
	def clean_text(data,feature):
		# import libraries
		import re
		import nltk                         # nlp library
		from nltk.corpus import stopwords   # import stopwords
		from nltk.stem import PorterStemmer # Class for stemming

		corpus = []
		for row in range(0,len(data)):
			text = data[feature][row]                        # get the row's text data
			review = re.sub('[^a-zA-Z]',' ',text)            # ^ = not : replace all non-alphabet with space
			review = review.lower()                          # convert all text to lower case
			review = review.split()                          # split whole string into a list of words

			# Now we do 2 task in one list comprehension
			# 1. remove non-significant words i.e articals/preposition 
			# 2. apply stemming to each signiicant word - stemming to get the root word to avoid sparsity

			ps = PorterStemmer()                             # object of stemming class
			review = [ps.stem(word) for word in review 
					  if not word in set(stopwords.words('english'))] 

			review = ' '.join(review)                        # reconverting the list of words back to string seperated by space
			corpus.append(review)
		return corpus
#=================================================================================================================

#=================================================================================================================

#=================================================================================================================

#=================================================================================================================

#################################################################################################################################
class act():
	def get_cat_yr_disc_cont(data):
		# categorical,yr,discrete,continuous = get_cat_yr_disc_cont(train)
		#make a list of Categorical, Year, Numerical(discrete and continuous)
		categorical = [col for col in data.columns if data[col].dtype == 'O']

		yr = [col for col in data.columns if 'Yr' in col or 'Year' in col]

		discrete = [col for col in data.columns if col not in categorical 
					and col not in yr 
					and data[col].nunique() < 20
				   ]
		continuous = [col for col in data.columns if col not in categorical
					 and col not in yr
					 and col not in discrete
					 and col not in ['Id']]

		print('There are {} categorical variables'.format(len(categorical)))
		print('There are {} temporal variables'.format(len(yr)))
		print('There are {} discrete variables'.format(len(discrete)))
		print('There are {} continuous variables'.format(len(continuous)))
		
		return categorical,yr,discrete,continuous
#=================================================================================================================
	def add_KBinsDiscretizer(df,categorical_feature,target,grp_num,col_dict=None):
		#prepare dictionary for Train set processing
		# KM Cluster mapping ran as below
		#train['SalePrice']=ytrain
		#for col in cat_grp_num.keys():
		#	 col_dict = add_KBinsDiscretizer(train,col,'SalePrice',cat_grp_num.get(col))
		#	 discard = add_KBinsDiscretizer(test,col,'SalePrice',cat_grp_num.get(col),col_dict)
		
		if col_dict==None:
			col_dict = df.groupby(categorical_feature)[target].mean().to_dict()

			#Map feature wrt dictionary
			feat = categorical_feature+'_KMeanBin'
			df[feat] = df[categorical_feature].map(col_dict)

			#Use clustering algo to group nearby labels
			from sklearn.preprocessing import KBinsDiscretizer
			rare_encoder = KBinsDiscretizer(n_bins=grp_num,encode='ordinal',strategy='kmeans')
			
			#Transforming the feature and adding to new column
			df[feat] = rare_encoder.fit_transform(df[feat].to_frame())
			df[feat] = df[feat].astype('int64')
			
			#Creating dictionary for test set
			mask = df[[categorical_feature,feat]].duplicated()
			mask = df[~mask][[categorical_feature,feat]]
			key = mask.iloc[:,0].values
			val = mask.iloc[:,1].values.astype('int64')
			col_dict = dict(zip(key,val))
		
		#Processing Test set
		else:
			feat = categorical_feature+'_KMeanBin'
			df[feat] = df[categorical_feature].map(col_dict)
			df[feat] = df[feat].fillna(df[feat].max()+1) # Handling Operation Problems
			df[feat] = df[feat].astype('int64')
		
		return col_dict
#=================================================================================================================
	def process_KBinsDiscretizer(train,test,target,cluster_dict):
		import partner as pal
		
		for col in cluster_dict.keys():
			col_dict = pal.act.add_KBinsDiscretizer(train,col,target,cluster_dict.get(col))
			discard = pal.act.add_KBinsDiscretizer(test,col,target,cluster_dict.get(col),col_dict)  
#=================================================================================================================
	def convert_int2Alp(train,feature_list):
		import pandas as pd

		result = pd.DataFrame()
		for feature in feature_list:
			tmp = (train[feature]+65).astype('int64')

			tmp1 = []
			for i in tmp:
				tmp1.append(chr(i))
			result[feature] = pd.Series(tmp1)

		return result
#=================================================================================================================
	def add_OutlierIndicator(df,feature_list, distance,mode='normal'):
		import pandas as pd
		import partner as pal
		import numpy as np
		
		results = pd.DataFrame()
		for variable in feature_list:
			if mode == 'normal':
				upper_boundary, lower_boundary = pal.eda.find_normal_boundaries(df, variable, distance)
				results[variable+'_Otlr'] = np.where(df[variable]>upper_boundary,1,np.where(df[variable]<lower_boundary,1,0))
				
			if mode == 'skew':
				upper_boundary, lower_boundary = pal.eda.find_skewed_boundaries(df, variable, distance)
				results[variable+'_Otlr'] = np.where(df[variable]>upper_boundary,1,np.where(df[variable]<lower_boundary,1,0))

		return results
#=================================================================================================================
	def get_PCA(data,feature_list,n,kernal = False):
		from sklearn.preprocessing import StandardScaler
		from sklearn.decomposition import PCA,KernelPCA
		from pandas import DataFrame

		# apply scaling
		ss = StandardScaler()
		x_train = ss.fit_transform(data[feature_list])

		# apply PCA for n component
		if kernal == True:
			pca = KernelPCA(n_components=n, kernel='rbf')
		else:
			pca = PCA(n_components= n)
		
		
		x_train = pca.fit_transform(x_train)

		return DataFrame(x_train)

#=================================================================================================================

#=================================================================================================================

#=================================================================================================================
#################################################################################################################################
class display():
	def LabelEffectOnTarget(df, feature_list, target,tolerance=0.05):
		#LabelEffectOnTarget(train,cat_revised,'Survived')
		import matplotlib.pyplot as plt
		import seaborn as sns
		import pandas as pd
		
		size = len(df)
		i=1
		for feature in feature_list:
			print('\033[1m',i,'.',feature,'\033[0m')
			temp_df = pd.DataFrame()
			temp_df['count'] = df[feature].value_counts() #calculating count
			temp_df['pct'] = df[feature].value_counts() / size #calculating %
			temp_df['avg_target'] = df.groupby([feature])[target].mean()  #calculating mean target
			temp_df['label_with_count'] = temp_df.index.astype(str)+'_'+temp_df['count'].astype(str)

			fig, ax = plt.subplots(figsize=(8, 4))

			ax.bar(temp_df['label_with_count'], temp_df["pct"], color='lightgrey')
			plt.xticks(temp_df['label_with_count'], temp_df['label_with_count'], rotation=90)

			ax2 = ax.twinx()
			ax2.plot(temp_df['label_with_count'], temp_df['avg_target'], color='green',marker='o', linestyle='dashed')

			ax.axhline(y=tolerance, color='red')
			
			#label preparation
			left_ylabel = "% "+feature
			right_ylabel = target+" Rate"
			
			ax.set_ylabel(left_ylabel)
			ax.set_xlabel(feature)
			ax2.set_ylabel(right_ylabel)

			plt.show()
			i=i+1

#=================================================================================================================
	def LabelEffectOnTargetN_wcss(df, feature_list, target,elbow=None,strategy='mean',tolerance=0.05):
		#LabelEffectOnTargetN_wcss(train,categorical,'Survived')

		#Importing Libraries
		#from sklearn.cluster import KMeans
		import matplotlib.pyplot as plt
		import seaborn as sns
		import pandas as pd

		size = len(df)
		feat_counter=1
		for feature in feature_list:
			print('\033[1m',feat_counter,'.',feature,'\033[0m')
			temp_df = pd.DataFrame()
			temp_df['count'] = df[feature].value_counts() #calculating count
			temp_df['pct'] = df[feature].value_counts() / size #calculating %
			if strategy == 'mean':
				temp_df['avg_target'] = df.groupby([feature])[target].mean()  #calculating mean target
			else:
				temp_df['avg_target'] = df.groupby([feature])[target].median()  #calculating median target

			temp_df['label_with_count'] = temp_df.index.astype(str)+'_'+temp_df['count'].astype(str)


			#initializing subplots
			#fig, ax1 = plt.subplots(figsize=(8, 4))
			fig, (ax1,ax3) = plt.subplots(nrows=1,ncols=2,figsize=(21, 6))

			#label preparation
			left_ylabel = "% "+feature
			right_ylabel = target+" Rate"

			#---------------------Plotting ax1(BAR Plot)---------------------#
			ax1.bar(temp_df['label_with_count'], temp_df["pct"], color='lightgrey')
			plt.sca(ax1)         #Set the axis to
			plt.xticks(temp_df['label_with_count'], temp_df['label_with_count'], rotation=45)
			plt.title('Cardinality & Target Relation')
			ax1.set_ylabel(left_ylabel)
			ax1.set_xlabel(feature)

			#---------------------Plotting ax2(Target on ax1 secondary)---------------------#
			ax1.axhline(y=tolerance, color='red')

			#Line graph on secondary axis
			ax2 = ax1.twinx()
			ax2.plot(temp_df['label_with_count'], temp_df['avg_target'], color='green',marker='o', linestyle='dashed')
			ax2.set_ylabel(right_ylabel)

			#---------------------Plotting ax3---------------------#
			from sklearn.cluster import KMeans

			#Creating data & dictionary
			tmp = df[feature]
			if strategy == 'mean':
				col_map = df.groupby(by=[feature])[target].mean().to_dict()
			else:
				col_map = df.groupby(by=[feature])[target].median().to_dict()

			#Creating x value
			x = tmp.map(col_map)

			wcss = []
			for i in range(1,len(x.unique())):
				kmeans = KMeans(n_clusters=i, init='k-means++', max_iter=300,n_init=10, random_state=0)
				kmeans.fit(x.to_frame())
				wcss.append(kmeans.inertia_)
				
			if (elbow==None) or (x.nunique() < elbow):
				plt.sca(ax3)
				ax3.plot(range(1,x.nunique()),wcss,color='lightgrey',marker='o',linestyle='dashed',markerfacecolor='red')
				plt.xticks(range(1,x.nunique()))
			else:
				ax3.plot(range(1,elbow+1),wcss[0:25],color='lightgrey',marker='o',linestyle='dashed',markerfacecolor='red')
				plt.xticks(range(1,elbow+1))
			plt.sca(ax3) 
			plt.title('KMean Elbow Method')
			plt.xlabel('Numbers of Clusters')
			plt.ylabel('Within Cluster sum of square (WCSS)')

			plt.show()
			feat_counter=feat_counter+1
#=================================================================================================================
	def NumericalDistribution(df, variable_list,target):
		#Only for numerical variable
		#NumericalDistribution(train,['LotFrontage'],'SalePrice')
		import pylab
		import scipy.stats as stats
		import matplotlib.pyplot as plt
		import seaborn as sns
		from scipy.stats import norm, skew

		i = 1
		for variable in variable_list:
			print('\033[1m',i,'.',variable,'\033[0m','( Correlation :',round(df.corr()[variable][target],4),')')
			plt.figure(figsize=(16, 4))

			try:
				# histogram
				plt.subplot(1, 3, 1)
				sns.distplot(df[variable],fit=norm, bins=30)
				plt.title('Histogram')
			except:
				sns.distplot(df[variable],fit=norm, kde=False)

			# Q-Q plot
			plt.subplot(1, 3, 2)
			stats.probplot(df[variable], dist="norm", plot=pylab)
			plt.ylabel('RM quantiles')

			# boxplot
			plt.subplot(1, 3, 3)
			sns.boxplot(y=df[variable])
			plt.title('Boxplot')
			plt.show()
			i=i+1
#=================================================================================================================			
	def CategoricalDistribution(df, feature_list, target,strategy='mean',tolerance=0.05):
		#LabelEffectOnTargetN_wcss(train,categorical,'Survived')

		#Importing Libraries
		#from sklearn.cluster import KMeans
		import matplotlib.pyplot as plt
		import seaborn as sns
		import pandas as pd

		size = len(df)
		feat_counter=1
		for feature in feature_list:
			print('\033[1m',feat_counter,'.',feature,'\033[0m')
			temp_df = pd.DataFrame()
			temp_df['count'] = df[feature].value_counts() #calculating count
			temp_df['pct'] = df[feature].value_counts() / size #calculating %
			if strategy == 'mean':
				temp_df['avg_target'] = df.groupby([feature])[target].mean()  #calculating mean target
			else:
				temp_df['avg_target'] = df.groupby([feature])[target].median()  #calculating median target

			temp_df['label_with_count'] = temp_df.index.astype(str)+'_'+temp_df['count'].astype(str)


			#initializing subplots
			#fig, ax1 = plt.subplots(figsize=(8, 4))
			fig, (ax1,ax3) = plt.subplots(nrows=1,ncols=2,figsize=(21, 6))

			#label preparation
			left_ylabel = "% "+feature
			right_ylabel = target+" Rate"

			#---------------------Plotting ax1(BAR Plot)---------------------#
			ax1.bar(temp_df['label_with_count'], temp_df["pct"], color='lightgrey')
			plt.sca(ax1)         #Set the axis to ax1
			plt.xticks(temp_df['label_with_count'], temp_df['label_with_count'], rotation=45)
			plt.title('Cardinality & Target Relation')
			ax1.set_ylabel(left_ylabel)
			ax1.set_xlabel(feature)

			#---------------------Plotting ax2(Target on ax1 secondary)---------------------#
			ax1.axhline(y=tolerance, color='red')

			#Line graph on secondary axis
			ax2 = ax1.twinx()
			ax2.plot(temp_df['label_with_count'], temp_df['avg_target'], color='green',marker='o', linestyle='dashed')
			ax2.set_ylabel(right_ylabel)

			#---------------------Plotting ax3---------------------#

			#Creating Box-Plot
			chart = sns.boxplot(data=df,x=feature,y=target,ax=ax3,notch=True)
			plt.sca(ax3) 
			chart.set_xticklabels(chart.get_xticklabels(), rotation=45)
			plt.title('Box-Plot')
			plt.xlabel('Labels')
			plt.ylabel('')
			plt.show()
			feat_counter=feat_counter+1
#=================================================================================================================
	def cat_Kmean_wcss(df,feature,target):
		#cat_Kmean_wcss(imputed_train,'Neighborhood','SalePrice')
		#importing libraries
		from sklearn.cluster import KMeans
		import matplotlib.pyplot as plt
		
		#Creating data & dictionary
		tmp = df[feature]
		col_map = df.groupby(by=[feature])[target].mean().to_dict()
		
		#Creating x value
		x = tmp.map(col_map)
		
		wcss = []
		for i in range(1,len(x.unique())):
			kmeans = KMeans(n_clusters=i, init='k-means++', max_iter=300,n_init=10, random_state=0)
			kmeans.fit(x.to_frame())
			wcss.append(kmeans.inertia_)
		
		plt.plot(range(1,x.nunique()),wcss,color='lightgrey',marker='o',linestyle='dashed',markerfacecolor='red')
		plt.title('The Elbow Method')
		plt.xlabel('Numbers of Clusters')
		plt.xticks(range(1,x.nunique()))
		plt.ylabel('within cluster sum of square(wcss)')
		plt.show()
#=================================================================================================================
	def numerical_deltaTrainNTest(train,test,feature_list,target):
		#continuous_deltaTrainNTest(train,test,continuous)
		import matplotlib.pyplot as plt
		import seaborn as sns
		from math import ceil
		row_num = ceil(len(feature_list)/2)
		i=1
		for feature in feature_list: 
			print('\033[1m',i,'.',feature,'\033[0m','( Correlation :',round(train.corr()[feature][target],4),')')
			
			plt.figure(figsize=(16, 4))
			
			sns.kdeplot(train[feature], bw='silverman', label='Training Set', shade=True)
			sns.kdeplot(test[feature], bw='silverman', label='Test Set', shade=True)
			plt.tick_params(axis='x', labelsize=12)
			plt.tick_params(axis='y', labelsize=12)
			plt.xlabel('{}'.format(feature), size=15)
			plt.legend(loc='best', prop={'size': 15})
			i=i+1
			plt.show()
#=================================================================================================================
	def heatmap(df):
		#Running : heatmap(train[features])
		import pandas as pd
		import matplotlib.pyplot as plt
		import seaborn as sns
		import numpy as np
		#Extracting information
		#df_tmp = pd.melt(df[features].corr().reset_index(), id_vars='index') # Unpivot the dataframe, so we can get pair of arrays for x and y
		df_tmp = pd.melt(df.corr().reset_index(), id_vars='index') # Unpivot the dataframe, so we can get pair of arrays for x and y
		df_tmp.columns = ['x', 'y', 'value'] #setting labels

		x = df_tmp['x']
		y = df_tmp['y']
		size = df_tmp['value'].abs()
		color = df_tmp['value']

		#starting the plot
		fig, ax = plt.subplots(figsize=(25,25)) #setting figure size

		plot_grid = plt.GridSpec(1, 15, hspace=0.2, wspace=0.1) # Setup a 1x15 grid for vertical bar
		ax = plt.subplot(plot_grid[:,:-1]) # Use the rightmost 14 columns of the grid for the main plot

		# Mapping from column names to integer coordinates
		x_labels = [v for v in sorted(x.unique())]
		y_labels = [v for v in sorted(y.unique())]
		x_to_num = {p[1]:p[0] for p in enumerate(x_labels)} 
		y_to_num = {p[1]:p[0] for p in enumerate(y_labels)} 

		#defining colors
		n_colors = 256 # Use 256 colors for the diverging color palette
		#palette = sns.diverging_palette(10, 130, n=n_colors) # Create the palette
		palette = sns.color_palette("PiYG", n_colors)
		color_min, color_max = [-1, 1] # Range of values that will be mapped to the palette, i.e. min and max possible correlation

		#function to get color value
		def value_to_color(val):
			val_position = ((val - color_min) / (color_max - color_min)) # position of value in the input range, relative to the length of the input range
			ind = (val_position * (n_colors - 1)) # target index in the color palette
			return palette[int(ind)]

		#Plotting the graph
		size_scale = 1000
		ax.scatter(
			x=x.map(x_to_num), # Use mapping for x
			y=y.map(y_to_num), # Use mapping for y
			s=size * size_scale, # Vector of square sizes, proportional to size parameter
			c=color.apply(value_to_color),
			marker='s' # Use square as scatterplot marker
		)

		# Show column labels on the axes
		ax.set_xticks([x_to_num[v] for v in x_labels])
		ax.set_xticklabels(x_labels, rotation=45, horizontalalignment='right')
		ax.set_yticks([y_to_num[v] for v in y_labels])
		ax.set_yticklabels(y_labels)

		#Shifting the gridlines to show squares in their cells
		ax.grid(False, 'major')
		ax.grid(True, 'minor')
		ax.set_xticks([t + 0.5 for t in ax.get_xticks()], minor=True)
		ax.set_yticks([t + 0.5 for t in ax.get_yticks()], minor=True)

		#Adjusting left and lower gridlines
		ax.set_xlim([-0.5, max([v for v in x_to_num.values()]) + 0.5]) 
		ax.set_ylim([-0.5, max([v for v in y_to_num.values()]) + 0.5])

		#Adding vertial color bar
		ax = plt.subplot(plot_grid[:,-1]) # Use the rightmost column of the plot
		col_x = [0]*len(palette) # Fixed x coordinate for the bars
		bar_y=np.linspace(color_min, color_max, n_colors) # y coordinates for each of the n_colors bars

		bar_height = bar_y[1] - bar_y[0]
		ax.barh(
		y=bar_y,
		width=[5]*len(palette), # Make bars 5 units wide
		left=col_x, # Make bars start at 0
		height=bar_height,
		color=palette,
		linewidth=0)

		ax.set_xlim(1, 2) # Bars are going from 0 to 5, so lets crop the plot somewhere in the middle
		ax.grid(False) # Hide grid
		ax.set_facecolor('white') # Make background white
		ax.set_xticks([]) # Remove horizontal ticks
		ax.set_yticks(np.linspace(min(bar_y), max(bar_y), 3)) # Show vertical ticks for min, middle and max
		ax.yaxis.tick_right() # Show vertical ticks on the right
#=================================================================================================================
	def save_fig(fig_name, tight_layout=True, fig_extension="png", resolution=300):
	# Just call this function with name of the image to be stored. i.e save_fig("Arvind)
		# Where to save the figures
		import os
		PROJECT_ROOT_DIR = "."
		CHAPTER_ID = "end_to_end_project"
		IMAGES_PATH = os.path.join(PROJECT_ROOT_DIR, "images", CHAPTER_ID)
		
		path = os.path.join(IMAGES_PATH, fig_name + "." + fig_extension)
		print("Saving figure", fig_name)
		if tight_layout:
			plt.tight_layout()
		try:
			plt.savefig(path, format=fig_extension, dpi=resolution)
		except:
			plt.savefig(fig_name + "." + fig_extension, format=fig_extension, dpi=resolution)
#=================================================================================================================
#=================================================================================================================
#=================================================================================================================
#################################################################################################################################
